include (jslib_dirutils);
include (jslib_prefs);

function MozImagePrefs() 
{
  this.prefs = new Prefs();
  this.load();
}

MozImagePrefs.prototype = {

load : 
  function () {
    this.homeDir = this.prefs.getChar("mozimage.home_directory");
    this.autoSize = this.prefs.getBool("mozimage.autosize");
    this.delay = this.prefs.getInt("mozimage.delay");

    this.top = Number(this.prefs.getInt("mozimage.top"));
    this.left = Number(this.prefs.getInt("mozimage.left"));
    this.height = Number(this.prefs.getInt("mozimage.height"));
    this.width = Number(this.prefs.getInt("mozimage.width"));

    this.extList = new Array("jpg", "jpeg", "gif", "bmp", "png");
    if (this.delay <= 0)
      this.delay = 2000;
    if (this.height <= 0)
      this.height = 500;
    if (this.width <= 0)
      this.width = 700;
    if (this.top <= 0)
      this.top = 0;
    if (this.left <= 0)
      this.left = 0;
   
    if (this.homeDir == "")
    {
      var dirUtils = new DirUtils();
      this.homeDir = dirUtils.getCurProcDir();
    }
  },
  
save : 
  function () {
    this.prefs.setChar("mozimage.home_directory", this.homeDir); 
    this.prefs.setBool("mozimage.autosize", this.autoSize); 
    this.prefs.setInt("mozimage.delay", this.delay); 

    this.prefs.setInt("mozimage.top", this.top); 
    this.prefs.setInt("mozimage.left", this.left); 
    this.prefs.setInt("mozimage.height", this.height); 
    this.prefs.setInt("mozimage.width", this.width); 
  },

getHomeDir : 
  function () { return(this.homeDir); },

setHomeDir : 
  function (aValue) { this.homeDir = aValue; },

getExtList : 
  function () { return(this.extList); },

setExtList : 
  function (aValue) { this.extList = aValue; },

getAutoSize : 
  function () { return(Boolean(this.autoSize)); },

setAutoSize : 
  function (aValue) { this.autoSize = Boolean(aValue); },

getDelay : 
  function () { return(Number(this.delay)); },

setDelay : 
  function (aValue) { this.delay = Number(aValue); },

getTop : 
  function () { return(Number(this.top)); },

setTop : 
  function (aValue) { this.top = Number(aValue); },

getLeft : 
  function () { return(Number(this.left)); },

setLeft : 
  function (aValue) { this.left = Number(aValue); },

getHeight : 
  function () { return(Number(this.height)); },

setHeight : 
  function (aValue) { this.height = Number(aValue); },

getWidth : 
  function () { return(Number(this.width)); },

setWidth : 
  function (aValue) { this.width = Number(aValue); }

} // END CLASS

/*
**
** Predefined instance of the preferences class
** do not use any other instances
**
*/

var prefs = new MozImagePrefs();

/*
**
** Prefs window event handlers
**
*/

function prefs_load()
{
  var homedir = document.getElementById("homedir-text");
  var delay = document.getElementById("delay-text");
  prefs.load();
  homedir.value = prefs.getHomeDir();
  delay.value = prefs.getDelay();
}

function prefs_close()
{
  var homedir = document.getElementById("homedir-text");
  var delay = document.getElementById("delay-text");
  prefs.setHomeDir(homedir.value);
  prefs.setDelay(delay.value);
  prefs.save();
}